#ifndef _SPEECH_COMPARISON_H_
#define _SPEECH_COMPARISON_H_

#include <stdio.h>
#include <stddef.h>

#include "lsc_error.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct ad_words ad_words;
/* This structure should be opaque to the user (hence the typedef) */
struct ad_result {
	FILE *result;
	size_t rsize;
	char *rptr;

	ad_words *ad_words;
};
typedef struct ad_result ad_result;

/**
 * struct ad_cfg - configuration for align detect
 *
 * @data_dir:  data directory. NULL for the default of DATA_DIR
 * @tmp_dir:   temporary diectory. NULL for the default of /tmp
 * @bench_wav: path to the benchmark WAVE file
 * @bench_fd:  OR file descriptor to an opened benchmark WAVE file
 * @samp_wav:  path to the sample WAVE file
 * @samp_fd:   OR file descriptor to an opened sample WAVE file
 * @word_file: path to file containing the text of the audio
 * @word_fd:   OR file descriptor to an opened words file
 */
struct ad_cfg {
	char *data_dir;
	char *tmp_dir;

	char *bench_wav;
	int bench_fd;
	char *samp_wav;
	int samp_fd;
	char *word_file;
	int word_fd;
};

#pragma GCC visibility push(default)

extern int ad_init(ad_result *ad_result, const struct ad_cfg *ad_cfg);
extern void ad_destroy(ad_result *ad_result);
extern int ad_execute(ad_result *ad_result);
extern const char *ad_get_result_str(const ad_result *ad_result);

#pragma GCC visibility pop

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
